Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr.instruct
Class FixedElement

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.instruct.Instruction
              net.sf.saxon.expr.instruct.ParentNodeConstructor
                  net.sf.saxon.expr.instruct.ElementCreator
                      net.sf.saxon.expr.instruct.FixedElement

All Implemented Interfaces:
  Serializable, SourceLocator, LocationProvider, SaxonLocator, DivisibleInstruction, TailCallReturner, ValidatingInstruction, InstructionInfo, Locator

    public class FixedElement

extends ElementCreator

An instruction that creates an element node whose name is known statically. Used for literal results elements in XSLT, for direct element constructors in XQuery, and for xsl:element in cases where the name and namespace are known statically.

See Also:
  Serialized Form

Field Summary
`protected NamespaceBinding[]` | `namespaceBindings`

Fields inherited from class net.sf.saxon.expr.instruct.ElementCreator
`inheritNamespaces`

Fields inherited from class net.sf.saxon.expr.instruct.ParentNodeConstructor
`content, preservingTypes`

Fields inherited from class net.sf.saxon.expr.Expression
`EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, EVENT_FEED_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, PROCESS_METHOD, PUSH_SELECTION, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, WATCH_METHOD`

Constructor Summary
`FixedElement(NodeName elementName, NamespaceBinding[] namespaceBindings, boolean inheritNamespaces, SchemaType schemaType, int validation)` Create an instruction that creates a new element node

Method Summary
`protected void` | `checkContentSequence(StaticContext env)` Check statically whether the content of the element creates attributes or namespaces after creating any child nodes
`void` | `checkPermittedContents(SchemaType parentType, StaticContext env, boolean whole)` Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
`Expression` | `copy()` Copy an expression.
`void` | `explain(ExpressionPresenter out)` Diagnostic print of expression structure.
`NamespaceBinding[]` | `getActiveNamespaces()` Callback to get a list of the intrinsic namespaces that need to be generated for the element.
`NodeName` | `getElementName()`
`NodeName` | `getElementName(XPathContext context, NodeInfo copiedNode)` Callback from the superclass ElementCreator to get the nameCode for the element name
`ItemType` | `getItemType(TypeHierarchy th)` Get the type of the item returned by this instruction
`String` | `getNewBaseURI(XPathContext context, NodeInfo copiedNode)` Get the base URI for the element being constructed
`Expression` | `optimize(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`protected void` | `outputNamespaceNodes(XPathContext context, Receiver out, NodeName nameCode, NodeInfo copiedNode)` Callback from the superclass ElementCreator to output the namespace nodes
`Expression` | `simplify(ExpressionVisitor visitor)` Simplify an expression.

Methods inherited from class net.sf.saxon.expr.instruct.ElementCreator
`computeSpecialProperties, evaluateItem, getImplementationMethod, isInheritNamespaces, iterateEvents, iterateEvents, processLeavingTail, processLeavingTail, processLeft, processLeft, processRight, suppressValidation`

Methods inherited from class net.sf.saxon.expr.instruct.ParentNodeConstructor
`addToPathMap, computeCardinality, createsNewNodes, getBaseURI, getCardinality, getContentExpression, getSchemaType, getValidationAction, isLazyConstruction, isNamespaceSensitive, isPreservingTypes, iterateSubExpressions, promoteInst, replaceSubExpression, setBaseURI, setContentExpression, setLazyConstruction, setNoNeedToStrip, setSchemaType, setValidationAction, typeCheck`

Methods inherited from class net.sf.saxon.expr.instruct.Instruction
`assembleParams, assembleTunnelParams, dynamicError, evaluateAsString, getConstructType, getExpressionName, getInstructionName, getInstructionNameCode, getIteratorFromProcessMethod, getSourceLocator, isXSLT, iterate, process, promote`

Methods inherited from class net.sf.saxon.expr.Expression
`adoptChildExpression, checkForUpdatingSubexpressions, computeDependencies, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, evaluatePendingUpdates, explain, getColumnNumber, getColumnNumber, getContainer, getDependencies, getEvaluationMethod, getExecutable, getHostLanguage, getIntegerBounds, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, hasVariableBinding, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterateSameFocusSubExpressions, markTailFunctionCalls, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, toString, typeError`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getLineNumber, getPublicId, getSystemId`

Field Detail

### namespaceBindings

    protected NamespaceBinding[] namespaceBindings

Constructor Detail

### FixedElement

    public FixedElement(NodeName elementName,
                        NamespaceBinding[] namespaceBindings,
                        boolean inheritNamespaces,
                        SchemaType schemaType,
                        int validation)

  Create an instruction that creates a new element node

  Parameters:
    `elementName` - Represents the name of the element node
    `namespaceBindings` - List of namespaces to be added to the element node. Supply an empty array if none are required.
    `inheritNamespaces` - true if the children of this element are to inherit its namespaces
    `schemaType` - Type annotation for the new element node
    `validation` - Validation mode to be applied, for example STRICT, LAX, SKIP

Method Detail

### simplify

    public Expression simplify(ExpressionVisitor visitor)
                        throws XPathException

  Simplify an expression. This performs any context-independent rewriting

  Overrides:
    `simplify` in class `ParentNodeConstructor`
  Parameters:
    `visitor` - the expression visitor
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### checkContentSequence

    protected void checkContentSequence(StaticContext env)
                                 throws XPathException

  Check statically whether the content of the element creates attributes or namespaces after creating any child nodes

  Overrides:
    `checkContentSequence` in class `ElementCreator`
  Parameters:
    `env` - the static context
  Throws:
    `XPathException`

### optimize

    public Expression optimize(ExpressionVisitor visitor,
                               ExpressionVisitor.ContextItemType contextItemType)
                        throws XPathException

  Description copied from class: `Expression`
  Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `ParentNodeConstructor`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### copy

    public Expression copy()

  Copy an expression. This makes a deep copy.

  Specified by:
    `copy` in class `Expression`
  Returns:
    the copy of the original expression

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Get the type of the item returned by this instruction

  Overrides:
    `getItemType` in class `ElementCreator`
  Parameters:
    `th` - The type hierarchy cache
  Returns:
    the item type

### getElementName

    public NodeName getElementName(XPathContext context,
                                   NodeInfo copiedNode)

  Callback from the superclass ElementCreator to get the nameCode for the element name

  Specified by:
    `getElementName` in class `ElementCreator`
  Parameters:
    `context` - The evaluation context (not used)
    `copiedNode` - For the benefit of the xsl:copy instruction, the node to be copied
  Returns:
    the name code for the element name

### getElementName

    public NodeName getElementName()

### getNewBaseURI

    public String getNewBaseURI(XPathContext context,
                                NodeInfo copiedNode)

  Description copied from class: `ElementCreator`
  Get the base URI for the element being constructed

  Specified by:
    `getNewBaseURI` in class `ElementCreator`
  Parameters:
    `context` - the XPath dynamic evaluation context
    `copiedNode` - the node being copied (for xsl:copy), otherwise null
  Returns:
    the base URI of the constructed element

### checkPermittedContents

    public void checkPermittedContents(SchemaType parentType,
                                       StaticContext env,
                                       boolean whole)
                                throws XPathException

  Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.

  Overrides:
    `checkPermittedContents` in class `Expression`
  Parameters:
    `parentType` - the "given complex type": the method is checking that the nodes returned by this expression are acceptable members of the content model of this type
    `env` - the static context
    `whole` - if true, we want to check that the value of this expression satisfies the content model as a whole; if false we want to check that the value of the expression is acceptable as one part of the content
  Throws:
    `XPathException` - if the value delivered by this expression cannot be part of the content model of the given type

### outputNamespaceNodes

    protected void outputNamespaceNodes(XPathContext context,
                                        Receiver out,
                                        NodeName nameCode,
                                        NodeInfo copiedNode)
                                 throws XPathException

  Callback from the superclass ElementCreator to output the namespace nodes

  Specified by:
    `outputNamespaceNodes` in class `ElementCreator`
  Parameters:
    `context` - The evaluation context (not used)
    `out` - The receiver to handle the output
    `nameCode` - the name of this element
    `copiedNode` - in the case of xsl:copy, the node being copied
  Throws:
    `XPathException` - if a dynamic error occurs

### getActiveNamespaces

    public NamespaceBinding[] getActiveNamespaces()

  Callback to get a list of the intrinsic namespaces that need to be generated for the element. The result is an array of namespace codes, the codes either occupy the whole array or are terminated by a -1 entry. A result of null is equivalent to a zero-length array.

  Overrides:
    `getActiveNamespaces` in class `ElementCreator`
  Returns:
    the set of namespace bindings.

### explain

    public void explain(ExpressionPresenter out)

  Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.

  Specified by:
    `explain` in class `Expression`
  Parameters:
    `out` - the expression presenter used to display the structure

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.